<!--
// -----------------------------------------------------
// copyright 2000 by voxeo corporation. (see LGPL.txt)
//
// -----------------------------------------------------
//
// v1.0 Coded in Active Server Pages
// v1.0 Coded by David Grobleski
//
// This application contains both a Web Browser and a phone 
// interface to a consumer poll application similar to those 
// found on CNN.com or other news portals.
// The user is presented with a poll question, and a series 
// of possible responses.  When the user chooses a response, 
// he/she is given the complete poll results.
// Written in ASP as sample code on how to use CallXML and 
// backend scripting languages.  
//
// This zip file contains the following files:				 
//     consumerpoll.mdb		<---- The actual database file itself
//     dbInclude.inc		<---- abstracted ODBC database constants (ASP)
//     LGPL.txt				<---- opensource license agreement
//     readme.txt			<---- Readme file
//     consumerpoll.css		<---- Client side style sheet for web interface
//     default.asp			<---- ASP version for introductory web interface
//     voxeo.asp			<---- This file.  ASP version for introductory phone interface
//     gatherpoll.asp		<---- ASP version that gathers consumer inputs for
//								  both web and phone versions
//     consumerPoll.sql		<---- SQL Scripts to create SQL Version of Database
//								  if desired
//
//     Please ensure that IUSR_Webserver has Read/Write permissions 
//     on the Access Database (if you are using access).  If not, you will 
//     get an error similar to "The operation must be an updatable query".
//
//
// There is one image file that is used to build the graph for the results 
// screen on the web based interface.  It should be placed in a subfolder 
// called "images":
//
// Several audio files are associated with this application.  They 
// should be placed in a subfolder called "voice":
//
//     ad1.wav
//     herestheresults.wav
//     percent.wav
//     q2_options.wav
//     q2_question.wav
//     q2option1.wav
//     q2option2.wav
//     q2option3.wav
//     q2option4.wav
//     q2option5.wav
//     questionheader.wav
//     received.wav
//     represents.wav
//     resultsfooter.wav
//     resultsheader.wav
//     staytuned.wav
//     votes.wav
//
// All audio files are PCM format, 8-bit, mono, unsigned.
//
//-------------------------------------------------------------------------->

<!--#include file="dbInclude.inc"-->
<?xml version="1.0" encoding="UTF-8"?>
<callxml>
	<assign var="audiourl" value="http://orlweb1.voxeo.com/applications/consumerpoll/voice/"/>
<%

'----------------------------------------------------------------------
' database access routines for retreiving the question and corresponding
' answers out of the ODBC database
'----------------------------------------------------------------------

Dim rsPoll, sqlPoll 

sqlPoll = "select *, A.ID as AnswerID from question Q left join answer A on Q.ID=A.QuestionID"
Set rsPoll = Server.CreateObject("ADODB.RecordSet")
connPoll.Open DSNtemp, "sa", ""

rsPoll.Open sqlPoll, ConnPoll, adOpenKeyset,adLockReadOnly

If NOT rsPoll.EOF Then
	rsPoll.MoveFirst

	Response.Write "<playAudio format=""audio/wav"" " & _
				  "value=""$audiourl;questionheader.wav"" " & _
				  "termDigits="""" " & _
				  "clearDigits=""TRUE""/>"
	Response.Write "<playAudio format=""audio/wav"" " & _
				  "value=""$audiourl;" & rsPoll("voicequestion") & """ " & _
				  "termDigits="""" " & _
				  "clearDigits=""TRUE""/>"

	Response.Write "<menu label=""options_menu"" " & _
				"repeat=""1"" " & _
				"format=""audio/wav"" " & _
				"value=""$audiourl;" & rsPoll("voiceoptions") & """ " & _
				"maxTime=""45s"" " & _
				"termDigits="""
	For i = 1 To rsPoll.RecordCount
		Response.Write i
	Next				  		
				  Response.Write "#"" " & _
				  "clearDigits=""TRUE"">"
	i = 1
	Do Until rsPoll.EOF
		Response.Write "<onTermDigit value=""" & i & """>"
		Response.Write "<goto value=""gatherpoll.asp?Presentation=callXML&amp;Answer=" & rsPoll("AnswerID") & """/>"
		Response.Write "</onTermDigit>"
		i = i + 1
		rsPoll.MoveNext
	Loop
	Response.Write "<onTermDigit value=""#"">" & vbCrLf & _
	"<goto value=""#options_menu""/>" & vbCrLf & _
	"</onTermDigit>" & vbCrLf
	Response.Write "</menu>"
Else
	
End If




%>


</callxml>
