<!--#include file="dbInclude.inc"-->
<%
' -----------------------------------------------------
' copyright 2000 by voxeo corporation. (see LGPL.txt)
'
' -----------------------------------------------------
'
' v1.0 Coded in Active Server Pages and PHP
' v1.0 Coded by David Grobleski
'
' This application contains both a Web Browser and a phone 
' interface to a consumer poll application similar to those 
' found on CNN.com or other news portals.
' The user is presented with a poll question, and a series 
' of possible responses.  When the user chooses a response, 
' he/she is given the complete poll results.
' Written in ASP as sample code on how to use CallXML and 
' backend scripting languages.  
'
' This zip file contains the following files:				 
'     consumerpoll.mdb		<---- The actual database file itself
'     dbInclude.inc			<---- abstracted ODBC database constants (ASP)
'     LGPL.txt				<---- opensource license agreement
'     readme.txt			<---- Readme file
'     consumerpoll.css		<---- Client side style sheet for web interface
'     default.php			<---- PHP version for introductory web interface
'     voxeo.php				<---- PHP version for introductory phone interface
'     gatherpoll.php		<---- PHP version that gathers consumer inputs for
'								  both web and phone versions
'     default.asp			<---- ASP version for introductory web interface
'     voxeo.asp				<---- ASP version for introductory phone interface
'     gatherpoll.asp		<---- This file.  ASP version that gathers consumer inputs for
'								  both web and phone versions
'     consumerPoll.sql		<---- SQL Scripts to create SQL Version of Database
'								  if desired
'
'     Please ensure that IUSR_Webserver has Read/Write permissions 
'     on the Access Database (if you are using access).  If not, you will 
'     get an error similar to "The operation must be an updatable query".
'
'
' There is one image file that is used to build the graph for the results 
' screen on the web based interface.  It should be placed in a subfolder 
' called "images":
'
' Several audio files are associated with this application.  They 
' should be placed in a subfolder called "voice":
'
'     ad1.wav
'     herestheresults.wav
'     percent.wav
'     q2_options.wav
'     q2_question.wav
'     q2option1.wav
'     q2option2.wav
'     q2option3.wav
'     q2option4.wav
'     q2option5.wav
'     questionheader.wav
'     received.wav
'     represents.wav
'     resultsfooter.wav
'     resultsheader.wav
'     staytuned.wav
'     votes.wav
'
' All audio files are PCM format, 8-bit, mono, unsigned.
'
'------------------------------------------------------------------------


'---------------------------------------------------------------------------
' Open the database to increment the chosen answer's "score" by one. 
'---------------------------------------------------------------------------

'---------------------------------------------------------------------------
' In a deployed environment a stored procedure would be helpful so when a 
' question's "score" is incremented, concurrency issues are not encountered.
' For example, a situation may occur whereby two users were selecting the 
' same answer at the same time.  If a regular sql statement is used, they 
' could possibly overwrite each other's responses.
'
' connPoll.Open DSNtemp, "sa", ""
' Set cmdPoll = Server.CreateObject("ADODB.Command")
'
' cmdPoll.ActiveConnection = connPoll
' cmdPoll.CommandText = "proc_Increment_AnswerCount"
' cmdPoll.Parameters.Append cmdPoll.CreateParameter("@AnswerID", adInteger, adParamInput, 4)
' cmdPoll.Parameters("@AnswerID") = Request("Answer")
' cmdPoll.CommandType = adCmdStoredProc
' cmdPoll.execute
'
'
' End of calls to Stored Procedure 
'---------------------------------------------------------------------------

'---------------------------------------------------------------------------
' For our purposes, we will simply implement a SQL Query to an Access 
' Database for the incrementation and other db calls
'---------------------------------------------------------------------------
      
connPoll.Open DSNtemp
Set rsUpdate = Server.CreateObject("ADODB.RecordSet")

sqlUpdate = "SELECT AnswerCount FROM answer WHERE answerID = " & Request("Answer")
Set rsUpdate = connPoll.Execute(sqlUpdate)

iAnswer = rsUpdate("AnswerCount") + 1

sqlUpdate = "UPDATE answer SET AnswerCount = " & iAnswer & " WHERE answerID = " & Request("Answer")
Set rsUpdate = connPoll.Execute(sqlUpdate)

'---------------------------------------------------------------------------
' End of Access db calls
'---------------------------------------------------------------------------

If Err.Number <> 0 Then
	Response.Write Err.Description
Else

'---------------------------------------------------------------------------
' open the database to retreive the correct answers for the poll question,
' as well as the total "score" for each question and present them to the 
' user
'---------------------------------------------------------------------------

	Dim rsPoll, runningTotal, percentage
	set rsPoll = server.createobject("ADODB.Recordset")
	rsPoll.open "select * from question Q left join answer A on Q.ID=A.QuestionID order by a.answerID", connPoll
	If Not rsPoll.eof then

'---------------------------------------------------------------------------
' A querystring parameter is passed to detirmine whether to pass HTML or 
' CallXML to the "browser".  The default is HTML view, but if the parameter 
' Presentation = callXML, the application will return CallXML
'---------------------------------------------------------------------------

		Presentation = Request.QueryString("Presentation")
		Select Case Presentation

'---------------------------------------------------------------------------
' callXML was passed.  Present CallXML to the "browser"
'---------------------------------------------------------------------------

		Case "callXML"
			Response.Write "<?xml version=""1.0"" encoding=""UTF-8""?>"
			Response.Write "<callxml>"
			Response.Write "<assign var=""audiourl"" value=""http://orlweb1.voxeo.com/applications/consumerpoll/voice/""/>"

'---------------------------------------------------------------------------
' Play "Stay Tuned" message and play an advertisement to the user
'---------------------------------------------------------------------------

			Response.Write "<playAudio format=""audio/wav"" " & _
				"value=""$audiourl;staytuned.wav"" " & _
				"termDigits="""" " & _
				"clearDigits=""TRUE""/>"
			
			Response.Write "<!-- play the Ad -->"

			Response.Write "<playAudio format=""audio/wav"" " & _
				"value=""$audiourl;" & rsPoll("voiceAd") & """ " & _
				"termDigits="""" " & _
				"clearDigits=""TRUE""/>"

			Response.Write "<playAudio format=""audio/wav"" " & _
				"value=""$audiourl;resultsheader.wav"" " & _
				"termDigits="""" " & _
				"clearDigits=""TRUE""/>"

'---------------------------------------------------------------------------
'  Play the question
'---------------------------------------------------------------------------

			Response.Write "<playAudio format=""audio/wav"" " & _
				"value=""$audiourl;" & rsPoll("voicequestion") & """ " & _
				"termDigits="""" " & _
				"clearDigits=""TRUE""/>"
			Response.Write "<playAudio format=""audio/wav"" " & _
				"value=""$audiourl;herestheresults.wav"" " & _
				"termDigits="""" " & _
				"clearDigits=""TRUE""/>"

			
			Response.Write "<!-- Calculate and read the results!! -->" & vbCrLf
			rsPoll.MoveFirst
			do until rsPoll.eof

'---------------------------------------------------------------------------
' Calculate the running total for each question, and for total responses
'---------------------------------------------------------------------------

				runningTotal = runningTotal + rsPoll("answerCount")		
				rsPoll.movenext
			loop

'---------------------------------------------------------------------------
' Loop through the recordset to read each response and it's corresponding 
' poll performance.  Calculate percentages, and read them to the user 
'---------------------------------------------------------------------------

			rsPoll.MoveFirst
			do until rsPoll.eof
				Response.Write "<!-- The answer at hand -->"

				Response.Write "<playAudio format=""audio/wav"" " & _
					"value=""$audiourl;" & rsPoll("voiceanswer") & """ " & _
					"termDigits="""" " & _
					"clearDigits=""TRUE""/>"


				Response.Write "<playAudio format=""audio/wav"" " & _
					"value=""$audiourl;received.wav"" " & _
					"termDigits="""" " & _
					"clearDigits=""TRUE""/>"

				Response.Write "<!-- number of votes for this option -->" & _
				"<playNumber format=""number"" " & _
					"value=""" & rsPoll("answercount") & """ " & _
					"termDigits="""" " & _
					"clearDigits=""TRUE""/>"
				

				Response.Write "<playAudio format=""audio/wav"" " & _
					"value=""$audiourl;votes.wav"" " & _
					"termDigits="""" " & _
					"clearDigits=""TRUE""/>"
				Response.Write "<playAudio format=""audio/wav"" " & _
					"value=""$audiourl;represents.wav"" " & _
					"termDigits="""" " & _
					"clearDigits=""TRUE""/>"

				Response.Write "<!-- percent of total votes -->"
				percentage = 100 * (rsPoll("answercount") / runningtotal)
				Response.Write "<playNumber format=""number"" " & _
					"value=""" & FormatNumber(percentage, 0) & """ " & _
					"termDigits="""" " & _
					"clearDigits=""TRUE""/>"

				Response.Write "<playAudio format=""audio/wav"" " & _
					"value=""$audiourl;percent.wav"" " & _
					"termDigits="""" " & _
					"clearDigits=""TRUE""/>"

				rsPoll.movenext
			loop
			
'---------------------------------------------------------------------------
' Done looping through each question.  End the callxml code
'---------------------------------------------------------------------------

			Response.Write "</callxml>"

'---------------------------------------------------------------------------
' Default response to the browser if no querystring is HTML.  So the same 
' funtionality above is duplicated, just with HTML tags instead of CallXML 
' tags.  WOW, the voxeo platform is easy.
'---------------------------------------------------------------------------
			
		Case Else
			Response.Write "<!DOCTYPE HTML PUBLIC ""-//W3C//DTD HTML 4.0 Transitional//EN"">" & _
			"<html>"
			Response.Write "<head><title>Consumer Poll</title>" & _
			"<link href=""voxeo.ums.style.css"" type=""text/css"" rel=""stylesheet"">" & _
			"</head><body>" & _
				"<table class=""pollTable"">" & _
					"<tr class=""question""><td colspan=4>" & rsPoll("textquestion") & "</td></tr>"

'---------------------------------------------------------------------------
' Loop through and get a running total of votes
'---------------------------------------------------------------------------

					rsPoll.MoveFirst
					do until rsPoll.eof
						runningTotal = runningTotal + rsPoll("answerCount")		
						rsPoll.movenext
					loop
					rsPoll.MoveFirst

'---------------------------------------------------------------------------
' Loop through the recordset to present each response and it's corresponding 
' poll performance.  Calculate percentages, and present them to the user 
'---------------------------------------------------------------------------

					do until rsPoll.eof
						response.write "<tr class=""answer"">"
						response.write "<td style=""margin-right: 10px"" width=""100"">" & rsPoll("textanswer") & "</td>"
						percentage = 100 * (rsPoll("answercount") / runningtotal) 						
						response.write "	<td VALIGN=""MIDDLE"" WIDTH=""120"" NOWRAP><FONT SIZE=""1""><img border=1 style=""border-color: #808080"" align=""left"" src=images/red.gif height=20 width=" & percentage & ">&nbsp;&nbsp;" & FormatNumber(percentage, 2) & "%</FONT></td>"
						response.write "	<td align=""right"">" & rsPoll("answercount") & "</td>"
						response.write "	<td align=""left"">votes</td>"
						response.write "</tr>"
						rsPoll.movenext
					loop

'---------------------------------------------------------------------------
' Done looping through each question.  End the callxml code
'---------------------------------------------------------------------------
					
					Response.Write "<TR><TD colspan=4><HR width=""90%""></TD></TR>"
					Response.Write "<TR class=""Answer""><TD colspan=""3"" align=""right"">total: <B>" & runningTotal & "</B></TD><TD>votes</TD></TR>"
					Response.Write "</table></body></html>"
		End Select
	End If
End if
%>
